## railcontrol 23%2Bdfsg1

=== debian/changelog ===
railcontrol (23+dfsg1-3) unstable; urgency=medium

  * Display distribution logo in the lower left corner of the web interface
    + Depend on desktop-base which provides that distribution logo
    + Document in README.Debian that the removed clock was non-DFSG
  * Fix typo in previous changelog entry

 -- Bruno Kleinert <fuddl@debian.org>  Fri, 28 Feb 2025 04:57:08 +0100

railcontrol (23+dfsg1-2) unstable; urgency=medium

  * Declared compliance with Standards Version 4.7.1. No changes were required.
  * Documented in manpage where a template configuration file is located.

 -- Bruno Kleinert <fuddl@debian.org>  Sat, 22 Feb 2025 06:45:24 +0100

railcontrol (23+dfsg1-1) unstable; urgency=medium

  * Initial release. (Closes: #1076247)

 -- Bruno Kleinert <fuddl@debian.org>  Sat, 08 Feb 2025 09:26:36 +0100

## railcontrol 23+dfsg1

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.1)

set(RAILCONTROL_VERSION "23")

project(CMakeTest)

add_executable(railcontrol
Storage/sqlite/sqlite3.c
Storage/sqlite/sqlite3.h
Storage/sqlite/sqlite3ext.h
Manager.cpp
Manager.h
Server/Web/WebClient.cpp
Server/Web/WebClient.h
ArgumentHandler.cpp
ArgumentHandler.h
Config.cpp
Config.h
ControlInterface.h
DataModel/Accessory.cpp
DataModel/Accessory.h
DataModel/AccessoryBase.cpp
DataModel/AccessoryBase.h
DataModel/AccessoryConfig.h
DataModel/Cluster.cpp
DataModel/Cluster.h
DataModel/DataModel.h
DataModel/Feedback.cpp
DataModel/Feedback.h
DataModel/FeedbackConfig.h
DataModel/HardwareHandle.cpp
DataModel/HardwareHandle.h
DataModel/Layer.h
DataModel/LayoutItem.cpp
DataModel/LayoutItem.h
DataModel/LockableItem.cpp
DataModel/LockableItem.h
DataModel/Loco.cpp
DataModel/Loco.h
DataModel/LocoBase.cpp
DataModel/LocoBase.h
DataModel/LocoConfig.h
DataModel/LocoFunctions.cpp
DataModel/LocoFunctions.h
DataModel/MultipleUnit.cpp
DataModel/MultipleUnit.h
DataModel/Object.cpp
DataModel/Object.h
DataModel/ObjectIdentifier.cpp
DataModel/ObjectIdentifier.h
DataModel/Relation.cpp
DataModel/Relation.h
DataModel/Route.cpp
DataModel/Route.h
DataModel/Serializable.cpp
DataModel/Serializable.h
DataModel/Signal.cpp
DataModel/Signal.h
DataModel/Switch.cpp
DataModel/Switch.h
DataModel/Text.cpp
DataModel/Text.h
DataModel/Track.cpp
DataModel/Track.h
DataTypes.h
Fallthrough.h
Hardware/AccessoryCache.cpp
Hardware/AccessoryCache.h
Hardware/CS1.h
Hardware/CS2Tcp.cpp
Hardware/CS2Tcp.h
Hardware/CS2Udp.cpp
Hardware/CS2Udp.h
Hardware/Capabilities.h
Hardware/CcSchnitte.cpp
Hardware/CcSchnitte.h
Hardware/DR5000.h
Hardware/DccPpExSerial.cpp
Hardware/DccPpExSerial.h
Hardware/DccPpExTcp.cpp
Hardware/DccPpExTcp.h
Hardware/Ecos.h
Hardware/FeedbackCache.cpp
Hardware/FeedbackCache.h
Hardware/HardwareHandler.cpp
Hardware/HardwareHandler.h
Hardware/HardwareInterface.h
Hardware/HardwareParams.h
Hardware/Hsi88.cpp
Hardware/Hsi88.h
Hardware/Intellibox.h
Hardware/Intellibox2.h
Hardware/LocoCache.cpp
Hardware/LocoCache.h
Hardware/LocoNetAdapter63120.h
Hardware/LocoNetAdapter63820.h
Hardware/M6051.cpp
Hardware/M6051.h
Hardware/MasterControl.h
Hardware/MasterControl2.h
Hardware/OpenDcc.h
Hardware/Protocols/DccPpEx.cpp
Hardware/Protocols/DccPpEx.h
Hardware/Protocols/EsuCAN.cpp
Hardware/Protocols/EsuCAN.h
Hardware/Protocols/LocoNet.cpp
Hardware/Protocols/LocoNet.h
Hardware/Protocols/LocoNetLocoCache.h
Hardware/Protocols/MaerklinCAN.cpp
Hardware/Protocols/MaerklinCAN.h
Hardware/Protocols/P50x.cpp
Hardware/Protocols/P50x.h
Hardware/Protocols/P50xCache.h
Hardware/Protocols/P50xEthernet.h
Hardware/Protocols/P50xSerial.h
Hardware/Protocols/P50xUhlenbrock.h
Hardware/Protocols/Z21.cpp
Hardware/Protocols/Z21.h
Hardware/Protocols/Z21FeedbackCache.h
Hardware/Protocols/Z21LocoCache.h
Hardware/Protocols/Z21TurnoutCache.h
Hardware/RedBox.h
Hardware/Rektor.h
Hardware/TwinCenter.h
Hardware/Virtual.cpp
Hardware/Virtual.h
Hardware/Z21.h
Hardware/ZLib.cpp
Hardware/ZLib.h
Languages.cpp
Languages.h
Logger/Logger.cpp
Logger/Logger.h
Logger/LoggerClient.h
Logger/LoggerClientConsole.h
Logger/LoggerClientFile.h
Logger/LoggerClientTcp.h
Logger/LoggerServer.cpp
Logger/LoggerServer.h
Network/Select.h
Network/Serial.cpp
Network/Serial.h
Network/TcpClient.cpp
Network/TcpClient.h
Network/TcpConnection.cpp
Network/TcpConnection.h
Network/TcpServer.cpp
Network/TcpServer.h
Network/UdpClient.h
Network/UdpConnection.cpp
Network/UdpConnection.h
Network/UdpServer.cpp
Network/UdpServer.h
RailControl.cpp
RailControl.h
Server/Web/HtmlTag.cpp
Server/Web/HtmlTag.h
Server/Web/HtmlTagAccessory.cpp
Server/Web/HtmlTagAccessory.h
Server/Web/HtmlTagButton.cpp
Server/Web/HtmlTagButton.h
Server/Web/HtmlTagButtonCancel.h
Server/Web/HtmlTagButtonCommand.cpp
Server/Web/HtmlTagButtonCommand.h
Server/Web/HtmlTagButtonCommandFullScreen.cpp
Server/Web/HtmlTagButtonCommandFullScreen.h
Server/Web/HtmlTagButtonCommandPressRelease.cpp
Server/Web/HtmlTagButtonCommandPressRelease.h
Server/Web/HtmlTagButtonCommandToggle.cpp
Server/Web/HtmlTagButtonCommandToggle.h
Server/Web/HtmlTagButtonCommandWide.h
Server/Web/HtmlTagButtonMinus.h
Server/Web/HtmlTagButtonOK.h
Server/Web/HtmlTagButtonPlus.h
Server/Web/HtmlTagButtonPopup.cpp
Server/Web/HtmlTagButtonPopup.h
Server/Web/HtmlTagButtonPopupWide.h
Server/Web/HtmlTagFeedback.cpp
Server/Web/HtmlTagFeedback.h
Server/Web/HtmlTagInput.cpp
Server/Web/HtmlTagInput.h
Server/Web/HtmlTagInputCheckbox.h
Server/Web/HtmlTagInputCheckboxWithLabel.h
Server/Web/HtmlTagInputHidden.h
Server/Web/HtmlTagInputInteger.cpp
Server/Web/HtmlTagInputInteger.h
Server/Web/HtmlTagInputIntegerWithLabel.h
Server/Web/HtmlTagInputSlider.cpp
Server/Web/HtmlTagInputSlider.h
Server/Web/HtmlTagInputSliderLocoSpeed.cpp
Server/Web/HtmlTagInputSliderLocoSpeed.h
Server/Web/HtmlTagInputText.h
Server/Web/HtmlTagInputTextWithLabel.h
Server/Web/HtmlTagLabel.h
Server/Web/HtmlTagLayoutItem.cpp
Server/Web/HtmlTagLayoutItem.h
Server/Web/HtmlTagRoute.cpp
Server/Web/HtmlTagRoute.h
Server/Web/HtmlTagSelect.cpp
Server/Web/HtmlTagSelect.h
Server/Web/HtmlTagSelectMultiple.cpp
Server/Web/HtmlTagSelectMultiple.h
Server/Web/HtmlTagSelectMultipleWithLabel.cpp
Server/Web/HtmlTagSelectMultipleWithLabel.h
Server/Web/HtmlTagSelectOrientation.h
Server/Web/HtmlTagSelectOrientationWithLabel.h
Server/Web/HtmlTagSelectWithLabel.cpp
Server/Web/HtmlTagSelectWithLabel.h
Server/Web/HtmlTagSignal.cpp
Server/Web/HtmlTagSignal.h
Server/Web/HtmlTagSwitch.cpp
Server/Web/HtmlTagSwitch.h
Server/Web/HtmlTagText.cpp
Server/Web/HtmlTagText.h
Server/Web/HtmlTagTrack.cpp
Server/Web/HtmlTagTrack.h
Server/Web/Response.cpp
Server/Web/Response.h
Server/Web/ResponseCsv.cpp
Server/Web/ResponseCsv.h
Server/Web/ResponseHtml.cpp
Server/Web/ResponseHtml.h
Server/Web/ResponseHtmlFull.cpp
Server/Web/ResponseHtmlFull.h
Server/Web/ResponseHtmlNotFound.cpp
Server/Web/ResponseHtmlNotFound.h
Server/Web/ResponseHtmlNotImplemented.cpp
Server/Web/ResponseHtmlNotImplemented.h
Server/Web/WebClientCluster.cpp
Server/Web/WebClientCluster.h
Server/Web/WebClientRoute.cpp
Server/Web/WebClientRoute.h
Server/Web/WebClientSignal.cpp
Server/Web/WebClientSignal.h
Server/Web/WebClientStatic.cpp
Server/Web/WebClientStatic.h
Server/Web/WebClientText.cpp
Server/Web/WebClientText.h
Server/Web/WebClientTrack.cpp
Server/Web/WebClientTrack.h
Server/Web/WebServer.cpp
Server/Web/WebServer.h
Server/Z21/Z21Client.cpp
Server/Z21/Z21Client.h
Server/Z21/Z21Server.cpp
Server/Z21/Z21Server.h
Storage/Sqlite.cpp
Storage/Sqlite.h
Storage/StorageHandler.cpp
Storage/StorageHandler.h
Storage/StorageInterface.h
Storage/StorageParams.h
Storage/TransactionGuard.cpp
Storage/TransactionGuard.h
Utils/Network.cpp
Utils/Network.h
Utils/ThreadSafeQueue.h
Utils/Utils.cpp
Utils/Utils.h
Version.cpp
Version.cpp.dummy
Version.cpp.in
Version.h
Hardware/zlib/adler32.c
Hardware/zlib/compress.c
Hardware/zlib/crc32.c
Hardware/zlib/crc32.h
Hardware/zlib/deflate.c
Hardware/zlib/deflate.h
Hardware/zlib/gzclose.c
Hardware/zlib/gzguts.h
Hardware/zlib/gzlib.c
Hardware/zlib/gzread.c
Hardware/zlib/gzwrite.c
Hardware/zlib/infback.c
Hardware/zlib/inffast.c
Hardware/zlib/inffast.h
Hardware/zlib/inffixed.h
Hardware/zlib/inflate.c
Hardware/zlib/inflate.h
Hardware/zlib/inftrees.c
Hardware/zlib/inftrees.h
Hardware/zlib/trees.c
Hardware/zlib/trees.h
Hardware/zlib/uncompr.c
Hardware/zlib/zconf.h
Hardware/zlib/zlib.h
Hardware/zlib/zutil.c
Hardware/zlib/zutil.h
)

set(CMAKE_SHARED_LIBRARY_LINK_CXX_FLAGS "")
set(CMAKE_CXX_STANDARD 11)
set(CMAKE_CXX_STANDARD_REQUIRED True)
set(CMAKE_CXX_FLAGS_DEBUG "-O0")
set(CMAKE_CXX_FLAGS_RELEASE "-O2")
set(CMAKE_CXX_FLAGS "-g -Wall -Wextra -pedantic -Werror")
set(CMAKE_C_FLAGS "-g -DSQLITE_ENABLE_FTS4 -DSQLITE_ENABLE_JSON1 -DSQLITE_ENABLE_RTREE -DHAVE_USLEEP -Wno-implicit-function-declaration -Wno-return-local-addr")

set(THREADS_PREFER_PTHREAD_FLAG ON)
find_package(Threads REQUIRED)
target_link_libraries(railcontrol PRIVATE Threads::Threads dl)

target_include_directories(railcontrol PRIVATE .)

add_custom_command(OUTPUT Version.cpp Version.cpp.dummy
	DEPENDS Version.cpp.in
	COMMAND git status -s| wc -l > ${CMAKE_CURRENT_SOURCE_DIR}/git_dirty.txt
	COMMAND sed s/@COMPILE_TIMESTAMP@/`date +%s`/ < ${CMAKE_CURRENT_SOURCE_DIR}/Version.cpp.in | sed s/@GIT_HASH@/`git log -1 --format=%H`/ | sed s/@GIT_TIMESTAMP@/`git log -1 --format=%at`/ | sed s,@GIT_DIRTY@,`cat ${CMAKE_CURRENT_SOURCE_DIR}/git_dirty.txt`, | sed s/@RAILCONTROL_VERSION@/${RAILCONTROL_VERSION}/ > ${CMAKE_CURRENT_SOURCE_DIR}/Version.cpp
	COMMAND rm ${CMAKE_CURRENT_SOURCE_DIR}/git_dirty.txt
	COMMENT "Creating Version.cpp")

=== Makefile ===

RAILCONTROL_VERSION := 23

CFLAGSSQLITE=-g -O2 -DSQLITE_ENABLE_FTS4 -DSQLITE_ENABLE_JSON1 -DSQLITE_ENABLE_RTREE -DHAVE_USLEEP
CFLAGSZLIB=-g -O2 -Wno-implicit-function-declaration -Wno-\#warnings -Wno-deprecated -Wno-deprecated-non-prototype
CXXFLAGS=-I. -g -O2 -Wall -Wextra -pedantic -Werror -Wno-missing-braces -std=c++11 -D_GNU_SOURCE
CXXFLAGSAMALGAMATION=-I. -g -O2 -Wall -Wextra -pedantic -Werror -Wno-missing-braces -std=c++11
LDFLAGS=-g
LIBS=-lpthread -ldl
LIBSAMALGAMATION=-lpthread -ldl

ifeq ($(OS),Windows_NT)
	LDFLAGS+= -static
endif

TMPDIR=/tmp/RailControl
TMPDIRCYGWIN=/RailControl

CXXOBJ= $(patsubst %.cpp,%.o,$(sort Version.cpp $(wildcard *.cpp)) $(wildcard Server/Web/*.cpp Server/Z21/*.cpp DataModel/*.cpp Hardware/*.cpp Hardware/Protocols/*.cpp Logger/*.cpp Network/*.cpp Storage/*.cpp Utils/*.cpp))
COBJ= $(patsubst %.c,%.o,$(wildcard Hardware/zlib/*.c))
OBJ=Storage/sqlite/sqlite3.o $(CXXOBJ) $(COBJ)

all: $(OBJ)
	$(CXX) $(LDFLAGS) $(OBJ) -o railcontrol $(LIBS)

dist: all
	strip railcontrol
	mkdir $(TMPDIR)
	cp -r \
		html \
		railcontrol.conf.dist \
		railcontrol \
		$(TMPDIR)
	( cd $(TMPDIR)/.. && tar cvJf railcontrol.`date +"%Y%m%d"`.tar.xz RailControl/* )
	rm -r $(TMPDIR)

dist-cygwin: all
	strip railcontrol.exe
	mkdir $(TMPDIRCYGWIN)
	cp -r \
		/cygdrive/c/Windows/SYSTEM32/ntdll.dll \
		/cygdrive/c/Windows/system32/KERNELBASE.dll \
		/cygdrive/c/Windows/system32/kernel32.dll \
		/usr/bin/cygwin1.dll \
		html \
		railcontrol.conf.dist \
		railcontrol.exe \
		$(TMPDIRCYGWIN)
	zip -9 railcontrol.windows.`date +"%Y%m%d"`.zip $(TMPDIRCYGWIN)/* $(TMPDIRCYGWIN)/html/*
	rm -r $(TMPDIRCYGWIN)

amalgamation.cpp:
	./amalgamation.bash

amalgamation: amalgamation.o Version.cpp Storage/sqlite/sqlite3.o $(COBJ)
	$(CXX) -g amalgamation.o Storage/sqlite/sqlite3.o Hardware/zlib/*.o -o railcontrol $(LIBSAMALGAMATION)
	rm -f amalgamation.o
	rm -f amalgamation.cpp

sqlite-shell:
	make -C Storage/sqlite

Version.o: Version.cpp Version.h
	$(CXX) $(CXXFLAGS) -c -o $@ $<

Hardware/zlib/%.o: Hardware/zlib/%.c Hardware/zlib/*.h
	$(CC) $(CFLAGSZLIB) -c -o $@ $<

Storage/sqlite/sqlite3.o: Storage/sqlite/sqlite3.c Storage/sqlite/sqlite3.h
	$(CC) $(CFLAGSSQLITE) -c -o $@ $<

%.o: %.cpp *.h DataModel/*.h Hardware/*.h Hardware/Protocols/*.h Logger/*.h Network/*.h Storage/*.h Utils/*.h Server/Web/*.h Server/Z21/*.h
	$(CXX) $(CXXFLAGS) -c -o $@ $<

.PHONY: clean
clean:
	rm -f *.o DataModel/*.o Hardware/*.o Hardware/Protocols/*.o Hardware/zlib/*.o Logger/*.o Network/*.o Storage/*.o Storage/sqlite/*.o Utils/*.o Server/Web/*.o Server/Z21/*.o
	rm -f railcontrol

clean-sqlite-shell:
	make -C Storage/sqlite clean

test:
	make -C test

tools:
	make -C tools

.PHONY: Version.cpp
Version.cpp: Version.cpp.in
	sed s/@COMPILE_TIMESTAMP@/`date +%s`/ < Version.cpp.in \
	| sed s/@GIT_HASH@/`git log -1 --format=%H`/ \
	| sed s/@GIT_TIMESTAMP@/`git log -1 --format=%at`/ \
	| sed "s/@GIT_DIRTY@/`git status -s| wc -l`/" \
	| sed s/@RAILCONTROL_VERSION@/$(RAILCONTROL_VERSION)/ \
	> Version.cpp

=== debian/control ===
Source: railcontrol
Section: misc
Priority: optional
Maintainer: Bruno Kleinert <fuddl@debian.org>
Rules-Requires-Root: no
Build-Depends:
 debhelper-compat (= 13),
 libsqlite3-dev,
 zlib1g-dev,
# Pandoc is for transforming debian/railcontrol.md into a manpage
 pandoc,
Standards-Version: 4.7.1
Homepage: https://www.railcontrol.org/
Vcs-Browser: https://salsa.debian.org/fuddl/railcontrol
Vcs-Git: https://salsa.debian.org/fuddl/railcontrol.git

Package: railcontrol
Architecture: any
Depends:
 desktop-base,
 ${shlibs:Depends},
 ${misc:Depends},
Description: A software for model railway control
 The handling is done with a webbrowser on the device of your choice. You can
 either control your trains, switches, signals manually or have the computer
 control your layout automatically.
 .
 The following controls are supported:
 * Arduino DCC-EX (formerly DCC++EX formerly DCC++)
 * CAN-Digital-Bahn CC-Schnitte 2.1
 * Digikejis DR5000
 * ESU Central Station Reloaded (beta)
 * ESU ECoS (beta)
 * Fleischmann Twin-Center
 * Gerhard Bertelsmann SRSE II (configured as Märklin CS2)
 * KM-1 System Control 7
 * LDT HSI-88 (RS-232-version only)
 * Märklin Central Station 1
 * Märklin Central Station 2
 * Märklin Central Station 3
 * Märklin Onterface 6050/6051
 * OpenDCC Z1
 * Roco Z21/z21
 * Tams Master Control
 * Tams Master Control 2
 * Tams Red Box
 * Uhlenbrock Adapter 63120
 * Uhlenbrock Adapter 63820
 * Uhlenbrock Intellibox
 * Uhlenbrock Intellibox II

=== debian/rules ===
#!/usr/bin/make -f

# See debhelper(7) (uncomment to enable).
# Output every command that modifies files on the build system.
#export DH_VERBOSE = 1


# See FEATURE AREAS in dpkg-buildflags(1).
#export DEB_BUILD_MAINT_OPTIONS = hardening=+all

# See ENVIRONMENT in dpkg-buildflags(1).
# Package maintainers to append CFLAGS.
#export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
# Package maintainers to append LDFLAGS.
#export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed


%:
	dh $@

execute_before_dh_installman:
	pandoc --standalone --from=markdown --to=man --output=debian/railcontrol.1 debian/railcontrol.md

execute_after_dh_clean:
	rm -f debian/railcontrol.1

download-missing-sources:
	curl --output debian/missing-sources/nosleep.js https://raw.githubusercontent.com/richtr/NoSleep.js/v0.12.0/dist/NoSleep.js

## railcontrol 24%2bdfsg1

=== debian/changelog ===
railcontrol (24+dfsg1-8) unstable; urgency=medium

  * Picked upstream development commits to get cmake build working:
    + Added 0001-Improve-build-toolchain-12.patch
    + Added
      0002-Allow-building-with-sqlite3-and-zlib-as-system-libraries-15.patch
      and replace link-against-system-sqlite.patch and
      link-against-system-zlib.patch
    + Added 0003-Support-packaging-using-CPack-18.patch
    + Added 0001-Check-if-stdin-is-a-tty-23.patch and replace
      check-if-stdin-is-a-tty.patch
    + Updated upstream copyright information
  * Added build dependency on cmake and dh-cmake and also build with cmake
  * Added disable-update-check.patch to remove the update checks completely
  * Added fix-cmake-installation.patch to complete the installation targets
    for cmake
  * Updated README.source to reflect the usage of the cmake switch to turn on
    system library linking

 -- Bruno Kleinert <fuddl@debian.org>  Mon, 12 Jan 2026 10:44:26 +0100

railcontrol (24+dfsg1-7) unstable; urgency=medium

  * Made the systemd service railcontrol.service log to the systemd journal
    + Updated README.Debian accordingly
    + Execute railcontrol no longer with --daemonize parameter
  * Added check-if-stdin-is-a-tty.patch to avoid 100% core load when stdin is
    a link to /dev/null
  * Declared compliance with Standards Version 4.7.3: Removed Priority field
    from debian/control, as 'Priority: optional' is redundant, now.

 -- Bruno Kleinert <fuddl@debian.org>  Fri, 09 Jan 2026 08:21:19 +0100

railcontrol (24+dfsg1-6) unstable; urgency=medium

  * Upload to unstable
  * Highlighted peculiarities of Debian's railcontrol.service even more in
    README.Debian

 -- Bruno Kleinert <fuddl@debian.org>  Mon, 08 Dec 2025 18:40:22 +0100

railcontrol (24+dfsg1-5) experimental; urgency=medium

  * Removed obsolete dependency on desktop-base
  * Delete state directory /var/lib/railcontrol when the package is purged
  * Create system user and group _railcontrol in maintainer scripts to comply
    with the Debian policy. It was Debian-railcontrol before. Maintainer
    scripts do not do any renaming magic as this would only affect users of
    experimental!

 -- Bruno Kleinert <fuddl@debian.org>  Wed, 03 Dec 2025 06:49:58 +0100

railcontrol (24+dfsg1-4) experimental; urgency=medium

  * Integrated with systemd
    + Added NEWS.Debian
    + Updated README.Debian accordingly
    + Added dependency on package adduser to binary package
    + Added maintainer scripts
    + Updated debian/rules to install systemd service in deactiveted state by
      default
  * Removed obsolete section 'Clock is not shown' from README.Debian

 -- Bruno Kleinert <fuddl@debian.org>  Thu, 27 Nov 2025 13:51:42 +0100

railcontrol (24+dfsg1-3) experimental; urgency=medium

  * Upload to experimental including the 'Counter' feature preview
    + Added 0001-Clean-up-code.patch and 0002-Object-counter-added.patch

 -- Bruno Kleinert <fuddl@debian.org>  Mon, 24 Nov 2025 15:29:36 +0100

railcontrol (24+dfsg1-2) unstable; urgency=medium

  * Harden build (Closes: #1119544)
    + Added read-compiler-flags-from-environment.patch
  * Fixed drop-in-versioncpp.patch to report version 24

 -- Bruno Kleinert <fuddl@debian.org>  Sun, 23 Nov 2025 13:47:16 +0100

railcontrol (24+dfsg1-1) unstable; urgency=medium

  * New upstream release
    + Removed obsolete clock_rewritten.patch, license issue solved upstream.
      Also removed obsolete linkage of distro logo which was used to replace
      the clock in previouse revisions. Removed respective section from
      README.source.
    + Removed remove-trailing-semicolon-in-default-config.patch, merged
      upstream.
    + Refreshed fix-paths.patch
    + Refreshed link-against-system-sqlite.patch
    + Refreshed link-against-system-zlib.patch
    + Updated upstream copyright years
  * Declared compliance with Standards Version 4.7.2
  * Added missing contributor to upstream authors

 -- Bruno Kleinert <fuddl@debian.org>  Thu, 01 May 2025 05:20:04 +0200

railcontrol (23+dfsg1-5) unstable; urgency=medium

  * Updated clock_rewritten.patch to fix memory consumption of web browsers

 -- Bruno Kleinert <fuddl@debian.org>  Fri, 28 Mar 2025 18:33:25 +0100

railcontrol (23+dfsg1-4) unstable; urgency=medium

  * Picked upstream patches to include a DFSG compliant clock in the web
    interface
    + Removed do-not-load-removed-station-clock.svg.patch
    + Added clock_rewritten.patch
    + Updated README.source accordingly
  * Simplifed debian/install

 -- Bruno Kleinert <fuddl@debian.org>  Tue, 25 Mar 2025 19:38:03 +0100

## railcontrol 24+dfsg1

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,6 +1,6 @@
-cmake_minimum_required(VERSION 3.1)
-
-set(RAILCONTROL_VERSION "23")
+cmake_minimum_required(VERSION 3.5)
+
+set(RAILCONTROL_VERSION "24")
 
 project(CMakeTest)
 
@@ -106,8 +106,9 @@
 Hardware/Protocols/LocoNet.cpp
 Hardware/Protocols/LocoNet.h
 Hardware/Protocols/LocoNetLocoCache.h
-Hardware/Protocols/MaerklinCAN.cpp
 Hardware/Protocols/MaerklinCAN.h
+Hardware/Protocols/MaerklinCANCommon.cpp
+Hardware/Protocols/MaerklinCANCommon.h
 Hardware/Protocols/P50x.cpp
 Hardware/Protocols/P50x.h
 Hardware/Protocols/P50xCache.h
@@ -153,6 +154,10 @@
 Network/UdpServer.h
 RailControl.cpp
 RailControl.h
+Server/CS2/CS2Client.cpp
+Server/CS2/CS2Client.h
+Server/CS2/CS2Server.cpp
+Server/CS2/CS2Server.h
 Server/Web/HtmlTag.cpp
 Server/Web/HtmlTag.h
 Server/Web/HtmlTagAccessory.cpp
@@ -252,6 +257,8 @@
 Storage/StorageParams.h
 Storage/TransactionGuard.cpp
 Storage/TransactionGuard.h
+Utils/Integer.cpp
+Utils/Integer.h
 Utils/Network.cpp
 Utils/Network.h
 Utils/ThreadSafeQueue.h

=== Makefile ===
--- 
+++ 
@@ -1,5 +1,5 @@
 
-RAILCONTROL_VERSION := 23
+RAILCONTROL_VERSION := 24
 
 CFLAGSSQLITE=-g -O2 -DSQLITE_ENABLE_FTS4 -DSQLITE_ENABLE_JSON1 -DSQLITE_ENABLE_RTREE -DHAVE_USLEEP
 CFLAGSZLIB=-g -O2 -Wno-implicit-function-declaration -Wno-\#warnings -Wno-deprecated -Wno-deprecated-non-prototype
@@ -16,12 +16,15 @@
 TMPDIR=/tmp/RailControl
 TMPDIRCYGWIN=/RailControl
 
-CXXOBJ= $(patsubst %.cpp,%.o,$(sort Version.cpp $(wildcard *.cpp)) $(wildcard Server/Web/*.cpp Server/Z21/*.cpp DataModel/*.cpp Hardware/*.cpp Hardware/Protocols/*.cpp Logger/*.cpp Network/*.cpp Storage/*.cpp Utils/*.cpp))
+CXXOBJ= $(patsubst %.cpp,%.o,$(sort Version.cpp $(wildcard *.cpp)) $(wildcard Server/Web/*.cpp Server/CS2/*.cpp Server/Z21/*.cpp DataModel/*.cpp Hardware/*.cpp Hardware/Protocols/*.cpp Logger/*.cpp Network/*.cpp Storage/*.cpp Utils/*.cpp))
 COBJ= $(patsubst %.c,%.o,$(wildcard Hardware/zlib/*.c))
 OBJ=Storage/sqlite/sqlite3.o $(CXXOBJ) $(COBJ)
 
 all: $(OBJ)
 	$(CXX) $(LDFLAGS) $(OBJ) -o railcontrol $(LIBS)
+
+strip: all
+	strip railcontrol
 
 dist: all
 	strip railcontrol
@@ -54,6 +57,7 @@
 
 amalgamation: amalgamation.o Version.cpp Storage/sqlite/sqlite3.o $(COBJ)
 	$(CXX) -g amalgamation.o Storage/sqlite/sqlite3.o Hardware/zlib/*.o -o railcontrol $(LIBSAMALGAMATION)
+	strip railcontrol
 	rm -f amalgamation.o
 	rm -f amalgamation.cpp
 
@@ -69,12 +73,12 @@
 Storage/sqlite/sqlite3.o: Storage/sqlite/sqlite3.c Storage/sqlite/sqlite3.h
 	$(CC) $(CFLAGSSQLITE) -c -o $@ $<
 
-%.o: %.cpp *.h DataModel/*.h Hardware/*.h Hardware/Protocols/*.h Logger/*.h Network/*.h Storage/*.h Utils/*.h Server/Web/*.h Server/Z21/*.h
+%.o: %.cpp *.h DataModel/*.h Hardware/*.h Hardware/Protocols/*.h Logger/*.h Network/*.h Storage/*.h Utils/*.h Server/Web/*.h Server/CS2/*.h Server/Z21/*.h
 	$(CXX) $(CXXFLAGS) -c -o $@ $<
 
 .PHONY: clean
 clean:
-	rm -f *.o DataModel/*.o Hardware/*.o Hardware/Protocols/*.o Hardware/zlib/*.o Logger/*.o Network/*.o Storage/*.o Storage/sqlite/*.o Utils/*.o Server/Web/*.o Server/Z21/*.o
+	rm -f *.o DataModel/*.o Hardware/*.o Hardware/Protocols/*.o Hardware/zlib/*.o Logger/*.o Network/*.o Storage/*.o Storage/sqlite/*.o Utils/*.o Server/Web/*.o Server/CS2/*.o Server/Z21/*.o
 	rm -f railcontrol
 
 clean-sqlite-shell:

=== test/Makefile ===

CC=g++

#CPPFLAGS=-g -O2 -Wall
#CPPFLAGS=-g -O0 -Wall -std=c++11
CPPFLAGS=-I. -g -O0 -Wall -std=c++11
LDFLAGS=-g
LIBS=-lpthread -ldl

TESTS= \
	testloco

all: $(TESTS)
	@./testloco

clean:
	rm -f $(TESTS) *.o

=== tools/Makefile ===

#CPPFLAGS=-g -O2 -Wall
#CPPFLAGS=-g -O0 -Wall -std=c++11
CXXFLAGS=-I. -I.. -g -O0 -Wall -std=c++11
LDFLAGS=-g
LIBS=-lpthread -ldl

TOOLS= \
	Cc-Schnitte-Sniffer

OBJ= \
	Cc-Schnitte-Sniffer.o \
	../Network/Serial.o \
	../Network/TcpConnection.o \
	../Network/TcpServer.o \
	../Logger/Logger.o \
	../Logger/LoggerServer.o \
	../Languages.o \
	../Utils/Utils.o

all: $(TOOLS)

%.o: %.cpp
	$(CXX) $(CXXFLAGS) -c -o $@ $<

Cc-Schnitte-Sniffer: $(OBJ)
	$(CXX) $(LDFLAGS) -o Cc-Schnitte-Sniffer Cc-Schnitte-Sniffer.o ../Logger/Logger.o ../Logger/LoggerServer.o ../Network/Serial.o ../Network/TcpServer.o ../Network/TcpConnection.o ../Languages.o ../Utils/Utils.o $(LIBS)

clean:
	rm -f $(TESTS) *.o

=== debian/control ===
--- 
+++ 
@@ -9,7 +9,7 @@
  zlib1g-dev,
 # Pandoc is for transforming debian/railcontrol.md into a manpage
  pandoc,
-Standards-Version: 4.7.1
+Standards-Version: 4.7.2
 Homepage: https://www.railcontrol.org/
 Vcs-Browser: https://salsa.debian.org/fuddl/railcontrol
 Vcs-Git: https://salsa.debian.org/fuddl/railcontrol.git
@@ -17,7 +17,7 @@
 Package: railcontrol
 Architecture: any
 Depends:
- desktop-base,
+ adduser,
  ${shlibs:Depends},
  ${misc:Depends},
 Description: A software for model railway control

=== debian/rules ===
--- 
+++ 
@@ -6,7 +6,7 @@
 
 
 # See FEATURE AREAS in dpkg-buildflags(1).
-#export DEB_BUILD_MAINT_OPTIONS = hardening=+all
+export DEB_BUILD_MAINT_OPTIONS = hardening=+all
 
 # See ENVIRONMENT in dpkg-buildflags(1).
 # Package maintainers to append CFLAGS.
@@ -18,12 +18,18 @@
 %:
 	dh $@
 
+execute_before_dh_install:
+	cp railcontrol.conf.dist railcontrol.conf
+
 execute_before_dh_installman:
 	pandoc --standalone --from=markdown --to=man --output=debian/railcontrol.1 debian/railcontrol.md
 
 execute_after_dh_clean:
 	rm -f debian/railcontrol.1
+	rm -f railcontrol.conf
 
 download-missing-sources:
 	curl --output debian/missing-sources/nosleep.js https://raw.githubusercontent.com/richtr/NoSleep.js/v0.12.0/dist/NoSleep.js
 
+override_dh_installsystemd:
+	dh_installsystemd --no-enable --no-start
